org.apache.lucene.index

## Class FilterLeafReader.FilterTermsEnum

- java.lang.Object
- - org.apache.lucene.index.TermsEnum
  - - org.apache.lucene.index.FilterLeafReader.FilterTermsEnum

All Implemented Interfaces:
  BytesRefIterator

Direct Known Subclasses:
  ExitableDirectoryReader.ExitableTermsEnum

Enclosing class:
  FilterLeafReader

    public abstract static class FilterLeafReader.FilterTermsEnum
    extends TermsEnum

Base class for filtering `TermsEnum` implementations.

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum

`TermsEnum.SeekStatus`

### Field Summary

Fields
`protected TermsEnum` `in` The underlying TermsEnum instance.

### Fields inherited from class org.apache.lucene.index.TermsEnum

`EMPTY`

### Constructor Summary

Constructors
Constructor and Description
`FilterTermsEnum(TermsEnum in)` Creates a new FilterTermsEnum

### Method Summary

All Methods Instance Methods Concrete Methods
`AttributeSource` `attributes()` Returns the related attributes.
`int` `docFreq()` Returns the number of documents containing the current term.
`BytesRef` `next()` Increments the iteration to the next `BytesRef` in the iterator.
`long` `ord()` Returns ordinal position for current term.
`PostingsEnum` `postings(PostingsEnum reuse, int flags)` Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required.
`TermsEnum.SeekStatus` `seekCeil(BytesRef text)` Seeks to the specified term, if it exists, or to the next (ceiling) term.
`void` `seekExact(long ord)` Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`.
`BytesRef` `term()` Returns current term.
`long` `totalTermFreq()` Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

### Methods inherited from class org.apache.lucene.index.TermsEnum

`postings, seekExact, seekExact, termState`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### in

    protected final TermsEnum in

The underlying TermsEnum instance.

### Constructor Detail

#### FilterTermsEnum

    public FilterTermsEnum(TermsEnum in)

Creates a new FilterTermsEnum

Parameters:
  `in` - the underlying TermsEnum instance.

### Method Detail

#### attributes

    public AttributeSource attributes()

Description copied from class: `TermsEnum`
Returns the related attributes.

Overrides:
  `attributes` in class `TermsEnum`

#### seekCeil

    public TermsEnum.SeekStatus seekCeil(BytesRef text)
                                  throws IOException

Description copied from class: `TermsEnum`
Seeks to the specified term, if it exists, or to the next (ceiling) term. Returns SeekStatus to indicate whether exact term was found, a different term was found, or EOF was hit. The target term may be before or after the current term. If this returns SeekStatus.END, the enum is unpositioned.

Specified by:
  `seekCeil` in class `TermsEnum`
Throws:
  `IOException`

#### seekExact

    public void seekExact(long ord)
                   throws IOException

Description copied from class: `TermsEnum`
Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`. The target ord may be before or after the current ord, and must be within bounds.

Specified by:
  `seekExact` in class `TermsEnum`
Throws:
  `IOException`

#### next

    public BytesRef next()
                  throws IOException

Description copied from interface: `BytesRefIterator`
Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.

Returns:
  the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
Throws:
  `IOException` - If there is a low-level I/O error.

#### term

    public BytesRef term()
                  throws IOException

Description copied from class: `TermsEnum`
Returns current term. Do not call this when the enum is unpositioned.

Specified by:
  `term` in class `TermsEnum`
Throws:
  `IOException`

#### ord

    public long ord()
             throws IOException

Description copied from class: `TermsEnum`
Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.

Specified by:
  `ord` in class `TermsEnum`
Throws:
  `IOException`

#### docFreq

    public int docFreq()
                throws IOException

Description copied from class: `TermsEnum`
Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.

Specified by:
  `docFreq` in class `TermsEnum`
Throws:
  `IOException`

#### totalTermFreq

    public long totalTermFreq()
                       throws IOException

Description copied from class: `TermsEnum`
Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). This will be -1 if the codec doesn't support this measure. Note that, like other term measures, this measure does not take deleted documents into account.

Specified by:
  `totalTermFreq` in class `TermsEnum`
Throws:
  `IOException`

#### postings

    public PostingsEnum postings(PostingsEnum reuse,
                                 int flags)
                          throws IOException

Description copied from class: `TermsEnum`
Get `PostingsEnum` for the current term, with control over whether freqs, positions, offsets or payloads are required. Do not call this when the enum is unpositioned. This method will not return null.

NOTE: the returned iterator may return deleted documents, so deleted documents have to be checked on top of the `PostingsEnum`.

Specified by:
  `postings` in class `TermsEnum`
Parameters:
  `reuse` - pass a prior PostingsEnum for possible reuse
  `flags` - specifies which optional per-document values you require; see `PostingsEnum.FREQS`
Throws:
  `IOException`